Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/iom_mpp.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/iom_mpp.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/iom_mpp.f90	(revision 5600)
@@ -589,381 +461,54 @@
       !----------------------------------------------------------------
 
-      ll_border=.FALSE.
-      IF( PRESENT(ld_border) ) ll_border=ld_border
-      ! check td_dom and ld_border optionals parameters...
-      IF( ll_border .AND. PRESENT(td_dom) )THEN
-         CALL logger_error( "IOM MPP READ VAR VALUE: &
-         &                domain and border can't be both specify")
-      ENDIF
-
-      IF( ll_border )THEN
-           
-         ! copy mpp structure
-         tl_mpp=td_mpp
-         ! forced to keep same id
-         tl_mpp%t_proc(:)%i_id=td_mpp%t_proc(:)%i_id
-
-         IF( ALL(td_mpp%t_proc(:)%l_ctr) )THEN
-            CALL logger_warn( "IOM MPP READ VAR VALUE: &
-            &               contour not define. look for it")
-            ! get contour
-            CALL mpp_get_contour( tl_mpp )
-         ENDIF
-         
-         ! Allocate space to hold variable value in structure
-         IF( ASSOCIATED(td_var%d_value) )THEN
-            DEALLOCATE(td_var%d_value)   
-         ENDIF
-
-         DO jk=1,ip_maxdim
-            IF( .NOT. td_var%t_dim(jk)%l_use ) tl_mpp%t_dim(jk)%i_len = 1
-         ENDDO
-  
-         ! use mpp global dimension 
-         td_var%t_dim(:)%i_len=tl_mpp%t_dim(:)%i_len
-
-         ALLOCATE(td_var%d_value( td_var%t_dim(1)%i_len, &
-         &                        td_var%t_dim(2)%i_len, &
-         &                        td_var%t_dim(3)%i_len, &
-         &                        td_var%t_dim(4)%i_len),&
-         &        stat=il_status)
-         IF(il_status /= 0 )THEN
-
-           CALL logger_error( &
-            &  " IOM MPP READ VAR VALUE: not enough space to put variable "//&
-            &  TRIM(td_var%c_name)//&
-            &  " in variable structure")
-
-         ENDIF
-
-         ! read border processor
-         DO jk=1,tl_mpp%i_nproc
-            IF( tl_mpp%t_proc(jk)%l_ctr )THEN
-                
-               CALL logger_debug(" IOM MPP READ VAR VALUE: name "//TRIM(td_var%c_name) )
-               CALL logger_debug(" IOM MPP READ VAR VALUE: ndim "//TRIM(fct_str(td_var%i_ndim)) )
-               tl_var=iom_read_var( tl_mpp%t_proc(jk), td_var%c_name )
-
-               ! get processor indices
-               il_ind(:)=mpp_get_proc_index( tl_mpp, jk )
-               il_i1p = il_ind(1)
-               il_i2p = il_ind(2)
-               il_j1p = il_ind(3)
-               il_j2p = il_ind(4)
-
-               IF( .NOT. td_var%t_dim(1)%l_use )THEN
-                  il_i1p=1 
-                  il_i2p=1 
-               ENDIF
-
-               IF( .NOT. td_var%t_dim(2)%l_use )THEN
-                  il_j1p=1 
-                  il_j2p=1 
-               ENDIF
-
-               ! replace value in mpp domain
-               td_var%d_value(il_i1p:il_i2p,il_j1p:il_j2p,:,:) = &
-               &  tl_var%d_value(:,:,:,:)
-
-               ! clean variable
-               CALL var_clean(tl_var)
-            ENDIF
-         ENDDO
-
-      ENDIF
-
-      IF( PRESENT(td_dom) )THEN
-
-         ! copy mpp structure
-         tl_mpp=td_mpp
-         ! forced to keep same id
-         tl_mpp%t_proc(:)%i_id=td_mpp%t_proc(:)%i_id         
-
-         IF( ALL(.NOT. td_mpp%t_proc(:)%l_use) )THEN
-            CALL logger_warn( "IOM MPP READ VAR VALUE: &
-            &               processor to be used not defined. look for it")
-            ! get processor to be used
-            CALL mpp_get_use( tl_mpp, td_dom )
-         ENDIF
-
-         ! Allocate space to hold variable value in structure
-         IF( ASSOCIATED(td_var%d_value) )THEN
-            DEALLOCATE(td_var%d_value)   
-         ENDIF
-         
-         tl_dom=td_dom
-         DO jk=1,ip_maxdim
-            IF( .NOT. td_var%t_dim(jk)%l_use ) tl_dom%t_dim(jk)%i_len = 1
-         ENDDO
-
-         ! use domain dimension 
-         td_var%t_dim(1:2)%i_len=tl_dom%t_dim(1:2)%i_len
-
-         ALLOCATE(td_var%d_value( tl_dom%t_dim(1)%i_len, &
-         &                        tl_dom%t_dim(2)%i_len, &
-         &                        td_var%t_dim(3)%i_len, &
-         &                        td_var%t_dim(4)%i_len),&
-         &        stat=il_status)
-         IF(il_status /= 0 )THEN
-
-           CALL logger_error( &
-            &  " IOM MPP READ VAR VALUE: not enough space to put variable "//&
-            &  TRIM(td_var%c_name)//&
-            &  " in variable structure")
-
-         ENDIF
-         CALL logger_debug("IOM MPP READ VAR VALUE: shape ("//&
-         &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=1)))//","//&
-         &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=2)))//","//&
-         &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=3)))//","//&
-         &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=4)))//")" )         
-         ! FillValue by default
-         td_var%d_value(:,:,:,:)=td_var%d_fill
-
-         IF( tl_dom%i_jmin < tl_dom%i_jmax )THEN
-         ! no north pole
-
-            IF( tl_dom%i_imin == 1 .AND. &
-            &   tl_dom%i_imax == tl_dom%t_dim0(1)%i_len )THEN
-            ! east west cyclic
-
-               CALL iom_mpp__no_pole_cyclic(tl_mpp, td_var, tl_dom)
-
-            ELSEIF( tl_dom%i_imin < tl_dom%i_imax )THEN
-            ! no east west overlap
-               
-               CALL iom_mpp__no_pole_no_overlap(tl_mpp, td_var, tl_dom)
-
-               ! no more EW overlap in variable
-               td_var%i_ew=-1
-
-            ELSEIF( tl_dom%i_imin > tl_dom%i_imax )THEN
-            ! east west overlap
-
-               CALL iom_mpp__no_pole_overlap(tl_mpp, td_var, tl_dom)
-
-               ! no more EW overlap in variable
-               td_var%i_ew=-1
-
-            ELSE
-
-               CALL logger_error(" IOM MPP READ VAR VALUE: invalid domain definition.")
-
-            ENDIF
-
-         ELSE ! tl_dom%i_jmin >= tl_dom%i_jmax
-         ! north pole
-
-         CALL logger_error("IOM MPP READ VAR VALUE: siren is not able to do so now "//&
-         &  "maybe in the next release")
-         !   IF( tl_dom%i_imin < tl_dom%i_imax )THEN
-         !   ! no east west overlap
-
-         !      CALL iom_mpp__pole_no_overlap(tl_mpp, td_var, tl_dom)
-
-         !   ELSEIF(tl_dom%i_imin == tl_dom%i_imax)THEN
-         !   ! east west cyclic
-
-         !      CALL iom_mpp__pole_cyclic(tl_mpp, td_var, tl_dom)
-
-         !    ELSE ! tl_dom%i_imin > tl_dom%i_imax
-         !    ! east west overlap
-
-         !      CALL iom_mpp__pole_overlap(tl_mpp, td_var, tl_dom)
-
-         !   ENDIF
-         ENDIF
-
-      ENDIF
-
-      ! force to change _FillValue to avoid mistake 
-      ! with dummy zero _FillValue
-      IF( td_var%d_fill == 0._dp )THEN
-         CALL var_chg_FillValue(td_var)
-      ENDIF      
-
-   END SUBROUTINE iom_mpp__read_var_value
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine read variable value
-   !> in an mpp structure. The output domain do not overlap
-   !> north fold boundary or east-west boundary.
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp__no_pole_no_overlap(td_mpp, td_var, td_dom )
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TMPP),  INTENT(IN)    :: td_mpp
-      TYPE(TVAR),  INTENT(INOUT) :: td_var
-      TYPE(TDOM),  INTENT(IN),   OPTIONAL :: td_dom
-
-      ! local variable
-      INTEGER(i4), DIMENSION(4) :: il_ind
-      INTEGER(i4)               :: il_i1p
-      INTEGER(i4)               :: il_j1p
-      INTEGER(i4)               :: il_i2p
-      INTEGER(i4)               :: il_j2p
-
-      INTEGER(i4)               :: il_i1
-      INTEGER(i4)               :: il_j1
-      INTEGER(i4)               :: il_i2
-      INTEGER(i4)               :: il_j2
-
-      INTEGER(i4), DIMENSION(4) :: il_start
-      INTEGER(i4), DIMENSION(4) :: il_count
-      TYPE(TVAR)                :: tl_var
-      TYPE(TDOM)                :: tl_dom
-
-      ! loop indices
-      INTEGER(i4) :: jk
-      !----------------------------------------------------------------
-      
-      ! change dimension length if not use
-      tl_dom=td_dom
-      IF( .NOT. td_var%t_dim(1)%l_use )THEN 
-         tl_dom%i_imin=1 ; tl_dom%i_imax=1
-      ENDIF
-      IF( .NOT. td_var%t_dim(2)%l_use )THEN 
-         tl_dom%i_jmin=1 ; tl_dom%i_jmax=1
-      ENDIF
-!      IF( .NOT. td_var%t_dim(3)%l_use )THEN 
-!         tl_dom%i_kmin=1 ; tl_dom%i_kmax=1
-!      ENDIF
-!      IF( .NOT. td_var%t_dim(4)%l_use )THEN 
-!         tl_dom%i_lmin=1 ; tl_dom%i_lmax=1
-!      ENDIF
-
-      ! read processor 
-      DO jk=1,td_mpp%i_nproc
-         IF( td_mpp%t_proc(jk)%l_use )THEN
-
-            ! get processor indices
-            il_ind(:)=mpp_get_proc_index( td_mpp, jk )
-            il_i1p = il_ind(1)
-            il_i2p = il_ind(2)
-            il_j1p = il_ind(3)
-            il_j2p = il_ind(4)
-
-            IF( .NOT. td_var%t_dim(1)%l_use )THEN
-               il_i1p=tl_dom%i_imin ; il_i2p=tl_dom%i_imax
-            ENDIF
-            IF( .NOT. td_var%t_dim(2)%l_use )THEN
-               il_j1p=tl_dom%i_jmin ; il_j2p=tl_dom%i_jmax
-            ENDIF
-
-            il_i1=MAX(il_i1p, tl_dom%i_imin)
-            il_i2=MIN(il_i2p, tl_dom%i_imax)
-
-            il_j1=MAX(il_j1p, tl_dom%i_jmin)
-            il_j2=MIN(il_j2p, tl_dom%i_jmax)
-
-            IF( (il_i1<=il_i2).AND.(il_j1<=il_j2) )THEN
-
-               il_start(:)=(/ il_i1-il_i1p+1, &
-               &              il_j1-il_j1p+1, &
-               &              1,1 /)
-!               &              tl_dom%i_kmin,  &
-!               &              tl_dom%i_lmin /)
-
-               il_count(:)=(/ il_i2-il_i1+1,         &
-               &              il_j2-il_j1+1,         &
-               &              td_var%t_dim(3)%i_len, &
-               &              td_var%t_dim(4)%i_len /)
-!               &              tl_dom%t_dim(3)%i_len, &
-!               &              tl_dom%t_dim(4)%i_len /)
-
-               tl_var=iom_read_var( td_mpp%t_proc(jk), td_var%c_name,&
-               &                    il_start(:), il_count(:) )
-
-               ! replace value in output variable structure
-               td_var%d_value( il_i1 - tl_dom%i_imin + 1 : &
-               &               il_i2 - tl_dom%i_imin + 1, &
-               &               il_j1 - tl_dom%i_jmin + 1 : &
-               &               il_j2 - tl_dom%i_jmin + 1, &
-               &               :,:) = tl_var%d_value(:,:,:,:)
-
-            ENDIF
-
-         ENDIF
+      il_start(:)=1
+      IF( PRESENT(id_start) ) il_start(:)=id_start(:)
+
+      il_count(:)=td_mpp%t_dim(:)%i_len
+      IF( PRESENT(id_count) ) il_count(:)=id_count(:)
+
+      DO jk=1,ip_maxdim
+         IF( .NOT. td_var%t_dim(jk)%l_use )THEN
+            il_start(jk) = 1
+            il_count(jk) = 1
+         ENDIF
+
+         il_end(jk)=il_start(jk)+il_count(jk)-1
       ENDDO
 
-   END SUBROUTINE iom_mpp__no_pole_no_overlap
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine read variable value
-   !> in an mpp structure. The output domain do not overlap north fold boundary.
-   !> However it uses cyclic east-west boundary.
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp__no_pole_cyclic(td_mpp, td_var, td_dom )
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TMPP),   INTENT(IN   ) :: td_mpp
-      TYPE(TVAR),   INTENT(INOUT) :: td_var
-      TYPE(TDOM),   INTENT(IN   ), OPTIONAL :: td_dom
-
-      ! local variable
-      INTEGER(i4), DIMENSION(4) :: il_ind
-      INTEGER(i4)               :: il_i1p
-      INTEGER(i4)               :: il_j1p
-      INTEGER(i4)               :: il_i2p
-      INTEGER(i4)               :: il_j2p
-
-      INTEGER(i4)               :: il_i1
-      INTEGER(i4)               :: il_j1
-      INTEGER(i4)               :: il_i2
-      INTEGER(i4)               :: il_j2
-
-      INTEGER(i4), DIMENSION(4) :: il_start
-      INTEGER(i4), DIMENSION(4) :: il_count
-      TYPE(TVAR)                :: tl_var
-      TYPE(TDOM)                :: tl_dom
-
-      ! loop indices
-      INTEGER(i4) :: jk
-      !----------------------------------------------------------------
-
-      ! change dimension length if not use
-      tl_dom=td_dom
-      IF( .NOT. td_var%t_dim(1)%l_use )THEN 
-         tl_dom%i_imin=1 ; tl_dom%i_imax=1
-      ENDIF
-      IF( .NOT. td_var%t_dim(2)%l_use )THEN 
-         tl_dom%i_jmin=1 ; tl_dom%i_jmax=1
-      ENDIF
-!      IF( .NOT. td_var%t_dim(3)%l_use )THEN 
-!         tl_dom%i_kmin=1 ; tl_dom%i_kmax=1
-!      ENDIF
-!      IF( .NOT. td_var%t_dim(4)%l_use )THEN 
-!         tl_dom%i_lmin=1 ; tl_dom%i_lmax=1
-!      ENDIF
+
+      IF( ANY(il_end(:) > td_mpp%t_dim(:)%i_len) )THEN
+            CALL logger_fatal("IOM MPP READ VAR VALUE: start + count "//&
+            &                 "exceed dimension bound.")
+      ENDIF
+
+      ! use domain dimension 
+      td_var%t_dim(:)%i_len=il_count(:)
+
+      ! Allocate space to hold variable value in structure
+      IF( ASSOCIATED(td_var%d_value) )THEN
+         DEALLOCATE(td_var%d_value)   
+      ENDIF
+
+      ALLOCATE(td_var%d_value( il_count(1), &
+      &                        il_count(2), &
+      &                        il_count(3), &
+      &                        il_count(4)),&
+      &        stat=il_status)
+      IF(il_status /= 0 )THEN
+
+        CALL logger_error( &
+         &  " IOM MPP READ VAR VALUE: not enough space to put variable "//&
+         &  TRIM(td_var%c_name)//&
+         &  " in variable structure")
+
+      ENDIF
+
+      CALL logger_debug("IOM MPP READ VAR VALUE: shape ("//&
+      &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=1)))//","//&
+      &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=2)))//","//&
+      &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=3)))//","//&
+      &  TRIM(fct_str(SIZE(td_var%d_value(:,:,:,:),DIM=4)))//")" )
+      ! FillValue by default
+      td_var%d_value(:,:,:,:)=td_var%d_fill
 
       ! read processor 
@@ -977,322 +522,71 @@
             il_j1p = il_ind(3)
             il_j2p = il_ind(4)
-
+ 
             IF( .NOT. td_var%t_dim(1)%l_use )THEN
-               il_i1p=tl_dom%i_imin ; il_i2p=tl_dom%i_imax
+               il_i1p=il_start(1) ; il_i2p=il_end(1)
             ENDIF
             IF( .NOT. td_var%t_dim(2)%l_use )THEN
-               il_j1p=tl_dom%i_jmin ; il_j2p=tl_dom%i_jmax
+               il_j1p=il_start(2) ; il_j2p=il_end(2)
+            ENDIF            
+            
+            il_i1=MAX(il_i1p, il_start(1))
+            il_i2=MIN(il_i2p, il_end(1))
+
+            il_j1=MAX(il_j1p, il_start(2))
+            il_j2=MIN(il_j2p, il_end(2))
+
+            IF( (il_i1<=il_i2).AND.(il_j1<=il_j2) )THEN
+               il_strt(:)=(/ il_i1-il_i1p+1, &
+               &             il_j1-il_j1p+1, &
+               &             1,1 /)
+
+               il_cnt(:)=(/ il_i2-il_i1+1,         &
+               &            il_j2-il_j1+1,         &
+               &            td_var%t_dim(3)%i_len, &
+               &            td_var%t_dim(4)%i_len /)
+
+               tl_var=iom_read_var( td_mpp%t_proc(jk), td_var%c_name,&
+               &                    il_strt(:), il_cnt(:) )
+               ! replace value in output variable structure
+               td_var%d_value( il_i1 - il_start(1) + 1 : &
+               &               il_i2 - il_start(1) + 1,  &
+               &               il_j1 - il_start(2) + 1 : &
+               &               il_j2 - il_start(2) + 1,  &
+               &               :,:) = tl_var%d_value(:,:,:,:)
+
+               ! clean
+               CALL var_clean(tl_var)
             ENDIF
 
-            il_i1=il_i1p
-            il_j1=MAX(il_j1p, td_dom%i_jmin)
-
-            il_i2=il_i2p
-            il_j2=MIN(il_j2p, td_dom%i_jmax)
-
-            IF( (il_i1<=il_i2).AND.(il_j1<=il_j2) )THEN
-
-               il_start(:)=(/ il_i1,          &
-               &              il_j1-il_j1p+1, &
-               &              1,1 /)
-!               &              tl_dom%i_kmin,  &
-!               &              tl_dom%i_lmin /)
-
-               il_count(:)=(/ il_i2-il_i1+1,         &
-               &              il_j2-il_j1+1,         &
-               &              td_var%t_dim(3)%i_len, &
-               &              td_var%t_dim(4)%i_len /)
-!               &              tl_dom%t_dim(3)%i_len, &
-!               &              tl_dom%t_dim(4)%i_len /)
-
-               tl_var=iom_read_var( td_mpp%t_proc(jk), td_var%c_name,&
-               &                    il_start(:), il_count(:) )
-
-               ! replace value in output variable structure
-               td_var%d_value( il_i1 : il_i2,  &
-               &               il_j1 - td_dom%i_jmin + 1 : &
-               &               il_j2 - td_dom%i_jmin + 1,  &
-               &               :,:) = tl_var%d_value(:,:,:,:)
-
-            ENDIF
-
          ENDIF
       ENDDO
 
-   END SUBROUTINE iom_mpp__no_pole_cyclic
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine read variable value
-   !> in an mpp structure. The output domain do not overlap north fold boundary. 
-   !> However it overlaps east-west boundary. 
-   !>
+      IF( td_var%t_dim(1)%l_use .AND. &
+      &   td_var%t_dim(1)%i_len == td_mpp%t_dim(1)%i_len )THEN
+         IF( td_mpp%i_ew >= 0 )THEN
+            tl_att=att_init("ew_overlap",td_mpp%i_ew)
+            CALL var_move_att(td_var,tl_att)
+            ! clean 
+            CALL att_clean(tl_att)
+         ENDIF
+      ENDIF
+
+      ! force to change _FillValue to avoid mistake 
+      ! with dummy zero _FillValue
+      IF( td_var%d_fill == 0._dp )THEN
+         CALL var_chg_FillValue(td_var)
+      ENDIF      
+
+   END SUBROUTINE iom_mpp__read_var_value
+   !-------------------------------------------------------------------
+   !> @brief This subroutine write files composing mpp structure.
+   !
    !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp__no_pole_overlap(td_mpp, td_var, td_dom )
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TMPP),   INTENT(IN)    :: td_mpp
-      TYPE(TVAR),   INTENT(INOUT) :: td_var
-      TYPE(TDOM),   INTENT(IN),   OPTIONAL :: td_dom
-
-      ! local variable
-      INTEGER(i4), DIMENSION(4) :: il_ind
-      INTEGER(i4)               :: il_i1p
-      INTEGER(i4)               :: il_j1p
-      INTEGER(i4)               :: il_i2p
-      INTEGER(i4)               :: il_j2p
-
-      INTEGER(i4)               :: il_i1
-      INTEGER(i4)               :: il_j1
-      INTEGER(i4)               :: il_i2
-      INTEGER(i4)               :: il_j2
-
-      INTEGER(i4)               :: il_ioffset
-
-      INTEGER(i4), DIMENSION(4) :: il_start
-      INTEGER(i4), DIMENSION(4) :: il_count
-      TYPE(TVAR)                :: tl_var
-      TYPE(TDOM)                :: tl_dom
-
-      ! loop indices
-      INTEGER(i4) :: jk
-      !----------------------------------------------------------------
-
-      il_ioffset  = (td_mpp%t_dim(1)%i_len-2) - td_dom%i_imin + 1
-
-      ! change dimension length if not use
-      tl_dom=td_dom
-      IF( .NOT. td_var%t_dim(1)%l_use )THEN 
-         tl_dom%i_imin=1 ; tl_dom%i_imax=1
-         il_ioffset=0
-      ENDIF
-      IF( .NOT. td_var%t_dim(2)%l_use )THEN 
-         tl_dom%i_jmin=1 ; tl_dom%i_jmax=1
-      ENDIF
-!      IF( .NOT. td_var%t_dim(3)%l_use )THEN 
-!         tl_dom%i_kmin=1 ; tl_dom%i_kmax=1
-!      ENDIF
-!      IF( .NOT. td_var%t_dim(4)%l_use )THEN 
-!         tl_dom%i_lmin=1 ; tl_dom%i_lmax=1
-!      ENDIF
-
-      ! read processor 
-      DO jk=1,td_mpp%i_nproc
-         IF( td_mpp%t_proc(jk)%l_use )THEN
-             
-            ! get processor indices
-            il_ind(:)=mpp_get_proc_index( td_mpp, jk )
-            il_i1p = il_ind(1)
-            il_i2p = il_ind(2)
-            il_j1p = il_ind(3)
-            il_j2p = il_ind(4)
-
-            IF( .NOT. td_var%t_dim(1)%l_use )THEN
-               il_i1p=tl_dom%i_imin ; il_i2p=tl_dom%i_imax
-            ENDIF
-            IF( .NOT. td_var%t_dim(2)%l_use )THEN
-               il_j1p=tl_dom%i_jmin ; il_j2p=tl_dom%i_jmax
-            ENDIF
-            
-            !!!!!! get first part of domain
-            il_i1=MAX(il_i1p, td_dom%i_imin)
-            il_j1=MAX(il_j1p, td_dom%i_jmin)
-
-            il_i2=MIN(il_i2p, td_mpp%t_dim(1)%i_len-td_var%i_ew) ! east-west overlap
-            il_j2=MIN(il_j2p, td_dom%i_jmax)
-
-            IF( (il_i1<=il_i2).AND.(il_j1<=il_j2) )THEN
-
-               il_start(:)=(/ il_i1-il_i1p+1, &
-               &              il_j1-il_j1p+1, &
-               &              1,1 /)
-!               &              tl_dom%i_kmin,  &
-!               &              tl_dom%i_lmin /)
-
-               il_count(:)=(/ il_i2-il_i1+1,         &
-               &              il_j2-il_j1+1,         &
-               &              td_var%t_dim(3)%i_len, &
-               &              td_var%t_dim(4)%i_len /)
-!               &              tl_dom%t_dim(3)%i_len, &
-!               &              tl_dom%t_dim(4)%i_len /)
-
-               tl_var=iom_read_var( td_mpp%t_proc(jk), td_var%c_name,&
-               &                    il_start(:), il_count(:) )
-
-               ! replace value in output variable structure
-               td_var%d_value( il_i1 - td_dom%i_imin + 1 : &
-               &               il_i2 - td_dom%i_imin + 1,  &
-               &               il_j1 - td_dom%i_jmin + 1 : &
-               &               il_j2 - td_dom%i_jmin + 1,  &
-               &               :,:) = tl_var%d_value(:,:,:,:)
-
-            ENDIF
-
-            !!!!! get second part of domain
-            il_i1=MAX(il_i1p, 1)
-            il_j1=MAX(il_j1p, td_dom%i_jmin)
-
-            il_i2=MIN(il_i2p, td_dom%i_imax)
-            il_j2=MIN(il_j2p, td_dom%i_jmax)
-
-            IF( (il_i1<=il_i2).AND.(il_j1<=il_j2) )THEN
-
-               il_start(:)=(/ il_i1,          &
-               &              il_j1-il_j1p+1, &
-               &              1,1 /)
-!               &              tl_dom%i_kmin,  &
-!               &              tl_dom%i_lmin /)
-
-               il_count(:)=(/ il_i2-il_i1+1,         &
-               &              il_j2-il_j1+1,         &
-               &              td_var%t_dim(3)%i_len, &
-               &              td_var%t_dim(4)%i_len /)
-!               &              tl_dom%t_dim(3)%i_len, &
-!               &              tl_dom%t_dim(4)%i_len /)
-
-               tl_var=iom_read_var( td_mpp%t_proc(jk), td_var%c_name,&
-               &                    il_start(:), il_count(:) )
-
-               ! replace value in output variable structure
-               td_var%d_value( il_ioffset + il_i1 :  &
-               &               il_ioffset + il_i2,   &
-               &               il_j1 - td_dom%i_jmin + 1 : &
-               &               il_j2 - td_dom%i_jmin + 1,  &
-               &               :,:) = tl_var%d_value(:,:,:,:)
-
-            ENDIF
-
-         ENDIF
-      ENDDO
-
-   END SUBROUTINE iom_mpp__no_pole_overlap
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine read variable value
-   !> in an mpp structure. The output domain overlaps
-   !> north fold boundary. However it do not overlap east-west boundary.
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-!   SUBROUTINE iom_mpp__pole_no_overlap(td_mpp, td_var, td_dom )
-!      IMPLICIT NONE
-!      ! Argument      
-!      TYPE(TMPP),   INTENT(IN)    :: td_mpp
-!      TYPE(TVAR),   INTENT(INOUT) :: td_var
-!      TYPE(TDOM),   INTENT(IN),   OPTIONAL :: td_dom
-!
-!      ! local variable
-!
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END SUBROUTINE iom_mpp__pole_no_overlap
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine read variable value
-   !> in an mpp structure. The output domain overlaps north fold boundary.
-   !> and uses cyclic east-west boundary.
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @param[in] ld_border : read only border
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-!   SUBROUTINE iom_mpp__pole_cyclic(td_mpp, td_var, td_dom )
-!      IMPLICIT NONE
-!      ! Argument      
-!      TYPE(TMPP),   INTENT(IN)    :: td_mpp
-!      TYPE(TVAR),   INTENT(INOUT) :: td_var
-!      TYPE(TDOM),   INTENT(IN),   OPTIONAL :: td_dom
-!
-!      ! local variable
-!
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END SUBROUTINE iom_mpp__pole_cyclic
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine read variable value
-   !> in an mpp structure. The output domain overlaps north fold boundary. 
-   !> and east-west boundary. 
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @param[in] ld_border : read only border
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-!   SUBROUTINE iom_mpp__pole_overlap(td_mpp, td_var, td_dom )
-!      IMPLICIT NONE
-!      ! Argument      
-!      TYPE(TMPP),   INTENT(IN)    :: td_mpp
-!      TYPE(TVAR),   INTENT(INOUT) :: td_var
-!      TYPE(TDOM),   INTENT(IN),   OPTIONAL :: td_dom
-!
-!      ! local variable
-!
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END SUBROUTINE iom_mpp__pole_overlap
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine write mpp structure in opened files.
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_mpp mpp structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_mpp_write_file(td_mpp)
       IMPLICIT NONE
@@ -1300,4 +594,5 @@
       TYPE(TMPP), INTENT(INOUT) :: td_mpp
 
+      ! local variable
       ! loop indices
       INTEGER(i4) :: ji
@@ -1312,4 +607,7 @@
          DO ji=1, td_mpp%i_nproc
             IF( td_mpp%t_proc(ji)%i_id /= 0 )THEN
+               !CALL file_del_att(td_mpp%t_proc(ji), 'periodicity')
+               !CALL file_del_att(td_mpp%t_proc(ji), 'ew_overlap')
+
                CALL iom_write_file(td_mpp%t_proc(ji))
             ELSE
@@ -1320,4 +618,3 @@
       ENDIF
    END SUBROUTINE iom_mpp_write_file
-   !> @endcode
 END MODULE iom_mpp
